import { world, system, ItemStack } from '@minecraft/server'


world.beforeEvents.worldInitialize.subscribe(eventData => {
    eventData.blockComponentRegistry.registerCustomComponent('twm:block_tick', {
        onTick(e) {
            const { block } = e
            const blockName = block.typeId.split('_')
            let players = block.dimension.getPlayers({ maxDistance: 4, location: block.location })

            for (let player of players) {
                const tags = player.getTags()
                if (tags.includes('twm:lava_waders_feet')) return
            }

            if (block.typeId == 'twm:lava_solid_0' || block.typeId == 'twm:lava_solid_1' || block.typeId == 'twm:lava_flow_0' || block.typeId == 'twm:lava_flow_1') {
                const next = blockName[0] + '_' + blockName[1] + '_' + `${parseInt(blockName[2]) + 1}`
                block.setType(`${next}`)
                return
            }
            if (block.typeId == 'twm:lava_solid_2') {
                block.setType('lava')
            }

            if (block.typeId == 'twm:lava_flow_2') {
                block.setType('air')
            }

        }
    })
})

